#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <utime.h>

int main(int argc, char* argv[]) {
  if (argc<3) {
    fprintf(stderr, "usage: chtime [-]SEC file\n\nAdjust modification time for SEC seconds\n");
    exit(1);
  }

  long sec = atoi(argv[1]);
  if (!sec) { fprintf(stderr, "Invalid SEC value\n"); exit(1); }
  
  struct stat st;
  struct utimbuf ub;
  
  if (stat(argv[2], &st)) { perror(argv[2]); exit(1); }
  
  ub.actime = st.st_atime; ub.modtime = st.st_mtime + sec;
  if (utime(argv[2], &ub)) { perror(argv[2]); exit(1); }
  
  return 0;
}

